import {NgModule, CUSTOM_ELEMENTS_SCHEMA} from '@angular/core';
import {RouterModule} from '@angular/router';

import { MpmSharedModule, JhiLanguageHelper } from '../../shared';
import { JhiLanguageService } from 'ng-jhipster';
import { customHttpProvider } from '../../blocks/interceptor/http.provider';
import { CommonModule } from '@angular/common';

import {
    VehicleDocumentRequirementService,
    VehicleDocumentRequirementPopupService,
    VehicleDocumentRequirementComponent,
    VehicleDocumentRequirementDialogComponent,
    VehicleDocumentRequirementPopupComponent,
    vehicleDocumentRequirementRoute,
    vehicleDocumentRequirementPopupRoute,
    VehicleDocumentRequirementResolvePagingParams,
    VehicleDocumentRequirementAsListComponent,
    VehicleDocumentRequirementAsLovComponent,
    VehicleDocumentRequirementLovPopupComponent,
    VehicleDocumentRequirementEditComponent,

    RegistrationDataTransaksiComponent,
    RegistrationIsiNamaComponent,
    RegistrationIsiNamaCancelComponent,
    RegistrationIsiNamaPengajuanFakturComponent,
    RegistrationIsiNamaDataBelumLengkapComponent,
    RegistrationIsiNamaDetailComponent,
    RegistrationIsiNamaEditComponent,
    RegistrationIsiNamaUploadComponent,

    RegistrationPenerimaanFakturComponent,
    RegistrationPenerimaanFakturNonComponent,
    RegistrationPenerimaanFakturRevisiComponent,
    RegistrationPenerimaanFakturUploadComponent,

    RegistrationPenerimaanBPKBSTNKComponent,
    RegistrationPenerimaanBPKBSTNKListRefComponent,
    RegistrationPenerimaanBPKBSTNKInputComponent,
    RegistrationPenerimaanBPKBSTNKRevisiComponent,

    RegistrationPengurusanBiroJasaComponent,
    RegistrationPengurusanBiroJasaPendingComponent,
    RegistrationPengurusanBiroJasaRevisiComponent,

    RegistrationBASTOffTheRoadComponent,
    RegistrationBASTSTNKInternalComponent,
    RegistrationBASTSTNKEksternalComponent,
    RegistrationBASTBPKBInternalComponent,
    RegistrationBASTSTNKBegbalComponent,
    RegistrationBASTSTNKDiterimaComponent,
    RegistrationBASTBPKBBegbalComponent,
    RegirasiBastStnkBegbalComponent,
    RegistrationPenerimaanSTNKInputComponent,
    RegistrationBASTSTNKlistRefrenceComponent,
    RegistrationBASTBPKBEksternalComponent,

    RegistrationPengurusanLuarWilayahReceiveComponent,
    RegistrationPengurusanLuarWilayahReceiveManualComponent,
    RegistrationPengurusanLuarWilayahReceiveRevisiComponent,

    RegistrationPengurusanLuarWilayahRequestComponent,
    RegistrationPengurusanLuarWilayahRequestRevisiComponent,
    IsiNamaEditDataCdbComponent,
    IsiNamaCustomerViewComponent,
    IsiNamaEditPersonComponent,
    IsiNamaEditPersonStnkComponent,
    IsiNamaEditOrganizationComponent,
    IsiNamaEditDataCdbOrganizationComponent,
    VehicleDocumentRequirementSalesComponent,
    VehicleDocumentRequirementSalesViewComponent,
    VehicleDocumentRequirementSalesBastComponent,
    VehicleDocumentRequirementSalesViewBastComponent

} from '.';

import { CurrencyMaskModule } from 'ng2-currency-mask';

import { CheckboxModule,
         InputTextModule,
         InputTextareaModule,
         CalendarModule,
         DropdownModule,
         EditorModule,
         ButtonModule,
         DataTableModule,
         DataListModule,
         DataGridModule,
         DataScrollerModule,
         CarouselModule,
         PickListModule,
         PaginatorModule,
         DialogModule,
         ConfirmDialogModule,
         ConfirmationService,
         FileUploadModule,
         GrowlModule,
         SharedModule,
         AccordionModule,
         TabViewModule,
         FieldsetModule,
         ScheduleModule,
         PanelModule,
         ListboxModule,
         ChartModule,
         DragDropModule,
         LightboxModule,
         RadioButtonModule,
         InputSwitchModule,
         AutoCompleteModule
        } from 'primeng/primeng';

import { MpmSharedEntityModule } from '../shared-entity.module';
// import { RegistrationPenerimaanFakturUploadComponent } from './registration-penerimaan-faktur-upload.component';

const ENTITY_STATES = [
    ...vehicleDocumentRequirementRoute,
    ...vehicleDocumentRequirementPopupRoute,
];

@NgModule({
    imports: [
        MpmSharedModule,
        MpmSharedEntityModule,
        RouterModule.forChild(ENTITY_STATES),
        CommonModule,
        EditorModule,
        InputTextareaModule,
        ButtonModule,
        DataTableModule,
        DataListModule,
        DataGridModule,
        DataScrollerModule,
        CarouselModule,
        PickListModule,
        PaginatorModule,
        ConfirmDialogModule,
        FileUploadModule,
        TabViewModule,
        ScheduleModule,
        CheckboxModule,
        CalendarModule,
        DropdownModule,
        ListboxModule,
        FieldsetModule,
        PanelModule,
        DialogModule,
        AccordionModule,
        PanelModule,
        ChartModule,
        DragDropModule,
        LightboxModule,
        CurrencyMaskModule,
        RadioButtonModule,
        InputSwitchModule,
        AutoCompleteModule
    ],
    exports: [
        VehicleDocumentRequirementComponent,
        VehicleDocumentRequirementAsListComponent,
        VehicleDocumentRequirementAsLovComponent,
        VehicleDocumentRequirementLovPopupComponent,
        VehicleDocumentRequirementEditComponent,

        RegistrationDataTransaksiComponent,
        RegistrationBASTSTNKBegbalComponent,
        RegistrationBASTSTNKDiterimaComponent,
        RegistrationBASTBPKBBegbalComponent,
        RegirasiBastStnkBegbalComponent,
        RegistrationPenerimaanSTNKInputComponent,
        RegistrationBASTSTNKlistRefrenceComponent,
        RegistrationIsiNamaComponent,
        RegistrationIsiNamaCancelComponent,
        RegistrationIsiNamaPengajuanFakturComponent,
        RegistrationIsiNamaDataBelumLengkapComponent,
        RegistrationIsiNamaDetailComponent,
        RegistrationIsiNamaEditComponent,
        RegistrationIsiNamaUploadComponent,

        RegistrationPenerimaanFakturComponent,
        RegistrationPenerimaanFakturNonComponent,
        RegistrationPenerimaanFakturRevisiComponent,
        RegistrationPenerimaanFakturUploadComponent,

        RegistrationPenerimaanBPKBSTNKComponent,
        RegistrationPenerimaanBPKBSTNKListRefComponent,
        RegistrationPenerimaanBPKBSTNKInputComponent,
        RegistrationPenerimaanBPKBSTNKRevisiComponent,

        RegistrationPengurusanBiroJasaComponent,
        RegistrationPengurusanBiroJasaPendingComponent,
        RegistrationPengurusanBiroJasaRevisiComponent,

        RegistrationBASTOffTheRoadComponent,
        RegistrationBASTSTNKInternalComponent,
        RegistrationBASTSTNKEksternalComponent,
        RegistrationBASTBPKBInternalComponent,
        RegistrationBASTBPKBEksternalComponent,

        RegistrationPengurusanLuarWilayahReceiveComponent,
        RegistrationPengurusanLuarWilayahReceiveManualComponent,
        RegistrationPengurusanLuarWilayahReceiveRevisiComponent,

        RegistrationPengurusanLuarWilayahRequestComponent,
        RegistrationPengurusanLuarWilayahRequestRevisiComponent,
        IsiNamaEditDataCdbComponent,
        IsiNamaCustomerViewComponent,
        IsiNamaEditPersonComponent,
        IsiNamaEditPersonStnkComponent,
        IsiNamaEditOrganizationComponent,
        IsiNamaEditDataCdbOrganizationComponent,
        VehicleDocumentRequirementSalesComponent,
        VehicleDocumentRequirementSalesViewComponent,
        VehicleDocumentRequirementSalesBastComponent,
        VehicleDocumentRequirementSalesViewBastComponent
    ],
    declarations: [
        VehicleDocumentRequirementComponent,
        VehicleDocumentRequirementDialogComponent,
        VehicleDocumentRequirementPopupComponent,
        VehicleDocumentRequirementAsListComponent,
        VehicleDocumentRequirementAsLovComponent,
        VehicleDocumentRequirementLovPopupComponent,
        VehicleDocumentRequirementEditComponent,

        RegistrationDataTransaksiComponent,
        RegistrationIsiNamaComponent,
        RegistrationIsiNamaCancelComponent,
        RegistrationIsiNamaPengajuanFakturComponent,
        RegistrationIsiNamaDataBelumLengkapComponent,
        RegistrationIsiNamaDetailComponent,
        RegistrationIsiNamaEditComponent,
        RegistrationIsiNamaUploadComponent,

        RegistrationPenerimaanFakturComponent,
        RegistrationPenerimaanFakturNonComponent,
        RegistrationPenerimaanFakturRevisiComponent,
        RegistrationPenerimaanFakturUploadComponent,

        RegistrationPenerimaanBPKBSTNKComponent,
        RegistrationPenerimaanBPKBSTNKListRefComponent,
        RegistrationPenerimaanBPKBSTNKInputComponent,
        RegistrationPenerimaanBPKBSTNKRevisiComponent,

        RegistrationPengurusanBiroJasaComponent,
        RegistrationPengurusanBiroJasaPendingComponent,
        RegistrationPengurusanBiroJasaRevisiComponent,

        RegistrationBASTOffTheRoadComponent,
        RegistrationBASTSTNKInternalComponent,
        RegistrationBASTSTNKEksternalComponent,
        RegistrationBASTSTNKBegbalComponent,
        RegistrationBASTBPKBBegbalComponent,
        RegirasiBastStnkBegbalComponent,
        RegistrationPenerimaanSTNKInputComponent,
        RegistrationBASTSTNKlistRefrenceComponent,
        RegistrationBASTSTNKDiterimaComponent,
        RegistrationBASTBPKBInternalComponent,
        RegistrationBASTBPKBEksternalComponent,

        RegistrationPengurusanLuarWilayahReceiveComponent,
        RegistrationPengurusanLuarWilayahReceiveManualComponent,
        RegistrationPengurusanLuarWilayahReceiveRevisiComponent,

        RegistrationPengurusanLuarWilayahRequestComponent,
        RegistrationPengurusanLuarWilayahRequestRevisiComponent,
        RegistrationPenerimaanFakturUploadComponent,
        IsiNamaEditDataCdbComponent,
        IsiNamaCustomerViewComponent,
        IsiNamaEditPersonComponent,
        IsiNamaEditPersonStnkComponent,
        IsiNamaEditOrganizationComponent,
        IsiNamaEditDataCdbOrganizationComponent,
        VehicleDocumentRequirementSalesComponent,
        VehicleDocumentRequirementSalesViewComponent,
        VehicleDocumentRequirementSalesBastComponent,
        VehicleDocumentRequirementSalesViewBastComponent
    ],
    entryComponents: [
        VehicleDocumentRequirementComponent,
        VehicleDocumentRequirementDialogComponent,
        VehicleDocumentRequirementPopupComponent,
        VehicleDocumentRequirementAsListComponent,
        VehicleDocumentRequirementAsLovComponent,
        VehicleDocumentRequirementLovPopupComponent,
        VehicleDocumentRequirementEditComponent,

        RegistrationDataTransaksiComponent,
        RegistrationIsiNamaComponent,
        RegistrationIsiNamaCancelComponent,
        RegistrationIsiNamaPengajuanFakturComponent,
        RegistrationIsiNamaDataBelumLengkapComponent,
        RegistrationIsiNamaDetailComponent,
        RegistrationIsiNamaEditComponent,
        RegistrationIsiNamaUploadComponent,

        RegistrationPenerimaanFakturComponent,
        RegistrationPenerimaanFakturNonComponent,
        RegistrationPenerimaanFakturRevisiComponent,
        RegistrationPenerimaanFakturUploadComponent,

        RegistrationPenerimaanBPKBSTNKComponent,
        RegistrationPenerimaanBPKBSTNKListRefComponent,
        RegistrationPenerimaanBPKBSTNKInputComponent,
        RegistrationPenerimaanBPKBSTNKRevisiComponent,

        RegistrationPengurusanBiroJasaComponent,
        RegistrationPengurusanBiroJasaPendingComponent,
        RegistrationPengurusanBiroJasaRevisiComponent,

        RegistrationBASTOffTheRoadComponent,
        RegistrationBASTSTNKInternalComponent,
        RegistrationBASTSTNKEksternalComponent,
        RegistrationBASTBPKBInternalComponent,
        RegistrationBASTSTNKBegbalComponent,
        RegistrationBASTSTNKDiterimaComponent,
        RegirasiBastStnkBegbalComponent,
        RegistrationBASTSTNKlistRefrenceComponent,
        RegistrationBASTBPKBBegbalComponent,
        RegistrationPenerimaanSTNKInputComponent,
        RegistrationBASTBPKBEksternalComponent,

        RegistrationPengurusanLuarWilayahReceiveComponent,
        RegistrationPengurusanLuarWilayahReceiveManualComponent,
        RegistrationPengurusanLuarWilayahReceiveRevisiComponent,

        RegistrationPengurusanLuarWilayahRequestComponent,
        RegistrationPengurusanLuarWilayahRequestRevisiComponent,
        IsiNamaEditDataCdbComponent,
        IsiNamaCustomerViewComponent,
        IsiNamaEditPersonComponent,
        IsiNamaEditPersonStnkComponent,
        IsiNamaEditOrganizationComponent,
        IsiNamaEditDataCdbOrganizationComponent,
        VehicleDocumentRequirementSalesComponent,
        VehicleDocumentRequirementSalesBastComponent,
        VehicleDocumentRequirementSalesViewBastComponent
    ],
    providers: [
        VehicleDocumentRequirementPopupService,
        VehicleDocumentRequirementResolvePagingParams,
        customHttpProvider(),
    ],
    schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class MpmVehicleDocumentRequirementModule {
    constructor(private languageService: JhiLanguageService, private languageHelper: JhiLanguageHelper) {
        this.languageHelper.language.subscribe((languageKey: string) => this.languageService.changeLanguage(languageKey));
    }
}
